!
!  HexHolesPsi.f90
!
!  Free-Format Fortran Source File 
!  Generated by PGI Visual Fortran(R)
!  10/5/2011 9:52:09 PM
!
module class_HexHolesPsi
use SharedTypes

	implicit none
	public ::  Evaluate

contains

	function make_HexHolesPsiContainer(n,m) result(outPsiContainer)
		integer :: n,m
		type (PsiContainer) :: outPsiContainer

		outPsiContainer = PsiContainer(n,m,3)


	end function make_HexHolesPsiContainer

	subroutine Evaluate(this,x,f,df)

		type(PsiContainer),intent(in) :: this
		real, intent(in) :: x
		real, intent(out) :: f,df
			
		integer n,m

		m=this%m
		n=this%n

		f = PsiEq(x,n,m)
		df = DiffPsiEq(x,n,m)

	end subroutine Evaluate

	function PsiEq(x,n,m) result(y)
	real :: x,y
	integer :: n,m
	real :: Pi =  3.141592653589793
		y=(n**2-m**2)*(sin(((n+m)*x-Pi)/m))**2-n*(n+2*m)*(sin((n*x-Pi)/m))**2+m*(2*n+m)*(sin(x))**2
		  

	end function PsiEq

	function DiffPsiEq(x,n,m) result(y)
	real :: x,y
	integer :: n,m
	real :: Pi =  3.141592653589793
		y=2*(n**2-m**2)*sin(((n+m)*x-Pi)/m)*cos(((n+m)*x-Pi)/m)*(n+m)/m-2*n**2*(n+2*m)*sin((n*x-Pi)/m)* & 
		cos((n*x-Pi)/m)/m+2*m*(2*n+m)*sin(x)*cos(x)
	end function DiffPsiEq

end module class_HexHolesPsi