﻿!
!  NanoTube.f90
!
!  Free-Format Fortran Source File 
!  Generated by PGI Visual Fortran(R)
!  9/27/2011 8:00:20 PM
!
module class_NanoTube
implicit none

	public :: NanoTube 
		
	type NanoTube 
		character (len=20) :: Name
		real  :: Sigma
		integer :: M
		integer :: N
		integer :: Length
		integer :: TubeType
		real :: Radius
	end type

	contains

	function make_NanoTube(tubeType,n,m) result (tube)
		integer :: tubeType,n,m
		type (NanoTube) :: tube

		tube%M=m
		tube%N=n
		tube%Length = 30
		tube%TubeType = tubeType
		tube%Radius = 0

		select case (tubeType)
			case (1)
				tube%Sigma = 1.42
				tube%Name ="C"
			case (2)
				tube%Sigma = 2.35
				tube%Name ="Si"
			case (3)
				tube%Sigma = 1.67
				tube%Name ="B"
		end select

	end function make_NanoTube

	function SetLength(this,length) result(tube)
		type (NanoTube) :: this,tube
		integer :: length

		this%Length = length

		tube = this

	end function SetLength
		
	function SetBondLength(this,bondLength) result(tube)
		type (NanoTube) :: this,tube
		real :: bondLength

		this%Sigma = bondLength

		tube = this

	end function SetBondLength

	subroutine AllocateXYZArray(this,xyz)
		real , allocatable :: xyz(:,:,:,:)
		type (NanoTube), intent(in) :: this

		integer :: atomCount,tubeLength

		tubeLength = this%Length

		if (this%M .eq. 0) then
			atomCount = this%N
		else
			atomCount = this%M
		end if

		select case (this%TubeType)
			case (1)
				allocate (xyz(2,atomCount,tubeLength+1,3))
			case (2)
				allocate (xyz(1,atomCount,tubeLength+1,3))
			case (3)
				allocate (xyz(1,atomCount,tubeLength+1,3))
		end select

	end subroutine AllocateXYZArray

end module