!
!  NewtonMethod.f90
!
!  Free-Format Fortran Source File 
!  Generated by PGI Visual Fortran(R)
!  9/28/2011 1:09:23 AM
!
module Solvers
use class_HexPsi,Hex_Evaluate => Evaluate
use class_PrismPsi, Prism_Evaluate => Evaluate
use class_HexHolesPsi, HexHoles_Evaluate => Evaluate
use SharedTypes
implicit none

contains

function NewtonRaphsonSafe(psic,x1,x2,xacc) result(rtsafe)
	integer :: MAXIT=100
	REAL :: rtsafe,x1,x2,xacc
	type (PsiContainer)  :: psic
	integer :: j
	real :: df,dx,dxold,f,fh,fl,temp,xh,xl
	

	call EvaluateStrategy(psic,x1,fl,df)
	call EvaluateStrategy(psic,x2,fh,df)

	if((fl.gt.0..and.fh.gt.0.) .or. (fl.lt.0..and.fh.lt.0.)) print *,"root must be bracketed in rtsafe"
	if(fl.eq.0.) then
		rtsafe=x1
		return
	else if(fh.eq.0.) then
		rtsafe=x2
		return
	else if(fl.lt.0.) then 
		xl=x1
		xh=x2
	else
		xh=x1
		xl=x2
	endif

	rtsafe=.5*(x1+x2) 
	dxold=abs(x2-x1) 
	dx=dxold 
	call EvaluateStrategy(psic,rtsafe,f,df)

	do j=1,MAXIT
		if (((rtsafe-xh)*df-f)*((rtsafe-xl)*df-f).gt.0. .or. abs(2.*f).gt.abs(dxold*df)) then
			dxold=dx
			dx=0.5*(xh-xl)
			rtsafe=xl+dx
			if (xl.eq.rtsafe) return 
		else 
			dxold=dx
			dx=f/df
			temp=rtsafe
			rtsafe=rtsafe-dx
			if (temp.eq.rtsafe) return
		end if
		if (abs(dx).lt.xacc) return

		call EvaluateStrategy(psic,rtsafe,f,df)

		if (f.lt.0.) then 
			xl=rtsafe
		else
			xh=rtsafe
		endif

	end do
	print *,"rtsafe exceeding maximum iterations"
	return
	end function NewtonRaphsonSafe

	subroutine EvaluateStrategy(psic,x,fl,df)
		type (PsiContainer) :: psic
		real :: x,fl,df

		select case (psic%PsiType)
			case (1)
				call Hex_Evaluate(psic,x,fl,df)
			case (2)
				call Prism_Evaluate(psic,x,fl,df)
			case (3)
				call HexHoles_Evaluate(psic,x,fl,df)
		end select


	end subroutine EvaluateStrategy

end module Solvers