!
!  ConsoleApp.f90
!
!  Fortran Console Application 
!  Generated by PGI Visual Fortran(R)
!  9/27/2011 2:09:14 AM
!  
!  The mathematical algorithms to construct the helix and calculate the tube radii were adapted from maple code sent to me by Richard K. F. Lee via personal communication
!  The Safe Newton-Raphson algorithm was adapted from 
!  Numerical Recipes in Fortran 77 - The Art of Scientific Computing - Second Edition/Volume 1


	

	  program prog_tubeXYZ
		
	  
	  use class_NanoTube
	  use CreateNanoTubeFromInput
	  use Solvers
	  use TubeBuilder
	  use OutputBuilder
	  use class_NanoTubeContainer
	  implicit none

	  

	  ! Variables
	  
	  real  :: sigma
	  character (len=200) :: fileName
	  integer :: tubeTotal,tubeIndex
	  type (NanoTube) :: tube

	  type (NanoTubeContainer) , allocatable :: tubeContainers(:)
	  type (NanoTubeContainer) :: currentTubeContainer

	  ! Body
	  call Welcome()
	  tubeTotal = HowManyNanoTubes()

	  allocate (tubeContainers(tubeTotal))

	  do tubeIndex=1,tubeTotal
		tube = EnterTube()
		currentTubeContainer = make_NanoTubeContainer(tube)

		call GetAtomsXYZByTube(currentTubeContainer%tube,currentTubeContainer%xyz)
		tubeContainers(tubeIndex) = currentTubeContainer

	  end do

	  

	 fileName = ChooseWhatKindOfFileToOutput()

	 call WriteToFile(tubeContainers,fileName)

	  
	  


	  end program prog_tubeXYZ

	  

	  

	  